%testiranje rada uz promjenu broja elitnih jedinki
options = gaoptimset('PopulationSize',300, 'Generations', 300);

global fja;
global a;
global b;
global mM;

poc=input('Koliko elitnih jedinki elite imati u poetku? ');
kon=input('Koliko elitnih jedinki elite imati na kraju? ');
za=input('Koliko novih elitnih jedinki elite dodavati u svakom novom pokretanju? ');

record=[];
record2=[];

figure;
subplot(2,2,[1 3]);
hold on

for n=poc:za:kon
	options = gaoptimset(options,'EliteCount', n);
	[x fval]=ga(fja, 1, options);
    
    fval=((-1)^mM)*fval; %invertira predznak kada se trai maksimum
    if x<a a=x-10;
    end
    if x>b b=x+10;
    end
    
    plot(x,fval,'--rs','LineWidth',1,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','g',...
                'MarkerSize',3);
    
    disp(['broj elitnih jedinki: ' num2str(n) ', x= ' num2str(x) ', y=' num2str(fval)])
	record = [record; x];
    record2 = [record2; fval];
    disp(' ');
end

plot(linspace(a,b,10000),((-1)^mM).*fja(linspace(a,b,10000)));    
grid;

subplot(2,2,2);
grid;
plot(poc:za:kon, record,'r');
xlabel('broj elitnih jedinki');
if mM==2 ylabel('pozicija minimuma');
end
if mM==3 ylabel('pozicija maksimuma');
end
grid

subplot(2,2,4);
plot(poc:za:kon, record2,'g');
xlabel('broj elitnih jedinki');
if mM==2 ylabel('vrijednost minimuma');
end
if mM==3 ylabel('vrijednost maksimuma');
end
grid