% funkcija za rjeavanje problema ruksaka
options=gaoptimset('PopulationType','bitstring');

global niz;
global volumen_ruksak;
global vol;
record=[];
record2=[];

volumen_ruksak=input('Unesite volumen ruksaka: ');

k=menu('elite li sami unijeti vrijednost i volumen robe ili da se to sluajno izgenerira?','sam u upisati','neka raunalo izgenerira');
if k==1 %korisnik upisuje roba
    niz=input('Niz treba upisati u formatu [vrijednost1, volumen1; ... vrijednostn, volumenn]\nUpiite niz: ');
end

if k==2 %robu generira raunalo
    broj=input('Broj komada: ');
    niz=round(rand(broj,2).*rand(1).*volumen_ruksak)
end
 
 broj_ponavljanja=input('Koliko puta elite pokrenuti genetski algoritam? ');
 pom=size(niz);
 brojj=pom(1);

 for i=0:1:broj_ponavljanja-1
     options=gaoptimset('PopulationType','bitstring','PopulationSize',round(rand(1)*200)+3,'Generations',round(rand(1)*300)+30, 'CrossoverFraction', rand(1));
    [x fval]=ga(@ruksaci, brojj, options);
    fval=-fval;
    
    ruksaci(x);
    
    disp([num2str(i) '. ukupna cijena=' num2str(fval) ', ukupni volumen= ' num2str(vol) ', x=' num2str(x)])
    
    record = [record; fval]; %cijene
    record2 = [record2; vol];
        
    disp(' ');
 end
 
figure;
subplot(2,1,1);
plot(0:1:broj_ponavljanja-1, record,'r');
xlabel('broj ponavljanja');
ylabel('ukupna cijena');
grid

subplot(2,1,2);
plot(0:1:broj_ponavljanja-1, record2,'g');
xlabel('broj ponavljanja');
ylabel('ukupni volumen');
grid
 
 
 
 