% testiranje rada uz promjenu poetne populacije
options = gaoptimset('PopulationSize',10, 'Generations', 300);

global fja;
global a;
global b;
global mM;

poc=1;
kon=input('Za koliko razliitih poetnih populacija elite ispitati? ');
za=1;

record=[];% inicijalizaija varijabli
record2=[];
pocetna=[];

figure;
subplot(2,2,[1 3]);
hold on

% generiranje jedinki poetnih populacija
for n=poc:za:kon
    pocetna=rand(options.PopulationSize,1).*0.5.*(b-a);
    
    pocetna_str=[];
    for ii=1:1:options.PopulationSize
        if ii ~= options.PopulationSize pocetna_str=[pocetna_str num2str(pocetna(ii,1)) ', '];
        end
        if ii == options.PopulationSize pocetna_str=[pocetna_str num2str(pocetna(ii,1))];
        end
    end
    
    
    disp([num2str(n) '. pocetna populacija: ']);
    disp([pocetna_str]);
	options = gaoptimset(options,'InitialPopulation', pocetna);
	[x fval]=ga(fja, 1, options);
    
    fval=((-1)^mM)*fval; %invertira predznak kada se trai maksimum
    if x<a a=x-10;
    end
    if x>b b=x+10;
    end
    
    plot(x,fval,'--rs','LineWidth',1,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','g',...
                'MarkerSize',3);
    
    disp(['x= ' num2str(x) ', y=' num2str(fval)])
	record = [record; x];
    record2 = [record2; fval];
    disp(' ');
end

plot(linspace(a,b,10000),((-1)^mM).*fja(linspace(a,b,10000)));    
grid;

subplot(2,2,2);
grid;
plot(poc:za:kon, record,'r');
xlabel('broj pocetne populacije');
if mM==2 ylabel('pozicija minimuma');
end
if mM==3 ylabel('pozicija maksimuma');
end
grid

subplot(2,2,4);
plot(poc:za:kon, record2,'g');
xlabel('broj pocetne populacije');
if mM==2 ylabel('vrijednost minimuma');
end
if mM==3 ylabel('vrijednost maksimuma');
end
grid